---
features:
  secondary:
  - name: "Allow initial push to protected branches"
    available_in: [core, premium, ultimate]  # Include all supported tiers
    gitlab_com: true
    documentation_link: 'https://docs.gitlab.com/ee/user/project/repository/branches/default.html#protect-initial-default-branches'
    image_url: '/images/16_2/govern-initial-push-protected-branch.png'
    reporter: derekferguson
    stage: software_supply_chain_security
    categories:
    - 'Compliance Management'
    - 'Source Code Management'
    issue_url: # Multiple links are supported. Avoid linking to confidential issues.
    - 'https://gitlab.com/gitlab-org/gitlab/-/issues/374003'
    description: |
      In previous versions of GitLab, when a default branch was fully protected, only project maintainers and owners could push an initial commit to a default branch.

      This caused problems for developers who created a new project, but couldn't push an initial commit to it because only the default branch existed.

      With the **Fully protected after initial push** setting, developers can push the initial commit to the default branch of a repository, but cannot push
      any commits to the default branch afterward. Similar to when a branch is fully protected, project maintainers can always push to the default branch but no one
      can force push.
